#ifndef __MSG_TYPE_H__
#define __MSG_TYPE_H__

enum MSG_TYPES {
// MAC messages
	MSG_TYPE_MAC_QUEUE,						// (0) A new message was queued
	MSG_TYPE_MAC_WAIT_TIME_E,				// (1) MAC ended waiting for E
	MSG_TYPE_MAC_WAIT_TIME_F,				// (2) MAC ended waiting initial idle period (F)
	MSG_TYPE_MAC_WAIT_TIME_G,				// (3) MAC ended waiting for guard time (G)
	MSG_TYPE_MAC_WAIT_TIME_H,				// (4) MAC ended waiting carrier time (H)
	MSG_TYPE_MAC_WAIT_TIME_P,				// (5) MAC ended waiting sync carrier time (P)
	MSG_TYPE_MAC_WAIT_TIME_SWX,				// (6) MAC ended waiting for RX/TX SWX
	MSG_TYPE_MAC_WAIT_TIME_TFCS,			// (7) MAC ended waiting for Time for Carrier Sense
	MSG_TYPE_MAC_WAIT_TIME_C,				// (8) MAC ended waiting for time to rx/tx messages
	MSG_TYPE_MAC_STATE_ENTER,				// (9) used when the MAC protocol enters a state, after a state transition with _toState()
	
// Radio messages
	MSG_TYPE_RADIO_SET_IDLE,				// (10) Tell radio to go idle
	MSG_TYPE_RADIO_SET_RX_DATA,				// (11) Tell radio to go to receive mode (receive data)
	MSG_TYPE_RADIO_SET_CARRIER_SENSE,		// (12) Tell radio to go to receive mode (carrier sense)
	MSG_TYPE_RADIO_SET_CARRIER_ON,			// (13) Tell radio to turn carrier signal on
	MSG_TYPE_RADIO_SET_CARRIER_OFF,			// (14) Tell radio to turn carrier signal off
	
	MSG_TYPE_RADIO_CARRIER_ON,				// (15) A carrier was transmitted
	MSG_TYPE_RADIO_CARRIER_OFF,				// (16) A carrier was turned off
	
	MSG_TYPE_RADIO_CHANNEL_BUSY,			// (17) Channel is busy (a carrier or a transmission detected)
	MSG_TYPE_RADIO_CHANNEL_IDLE,			// (18) Channel is idle
	MSG_TYPE_RADIO_START_RX,				// (19)
	MSG_TYPE_RADIO_END_RX,					// (20) 
	MSG_TYPE_RADIO_RX_ERROR,				// (21)
	MSG_TYPE_RADIO_END_TX,					// (22)
	
	MSG_TYPE_RADIO_TFCS,					// (23) TFCS time has elapsed since last reception of carrier signal
	MSG_TYPE_RADIO_TURN_AROUND_RXTX,		// (24) tx/rx turnaround time has elapsed
	MSG_TYPE_RADIO_END_CS,					// (25) end carrier sense

// Other	
	MSG_TYPE_MAC_DO_ASSERT					// (26)
};

const int MSG_TYPE_DATA_MSG = MSG_TYPE_RADIO_START_RX;
#endif
