#ifndef __OBSERVER_H__
#define __OBSERVER_H__

//! Observer simple module class definition
/*
    This is used to observe results of the tourmaments.

	\author	Nuno Pereira
	\date May 2006.
*/
class Observer : public cSimpleModule
{
// Member variables
private:
	bool coll, pError, trnmt;
	long prioErrorCounter, collisionCounter, messageTxCounter, tournamentCounter, tournamentErrorCounter;
	long prioErrorCounterMultiplicity, collisionCounterMultiplicity, messageTxCounterMultiplicity;
	
	cOutVector prioErrorVector;	
    cOutVector collisionVector;
    cOutVector messageTxVector;
			
// Member functions
public:
    Module_Class_Members(Observer,cSimpleModule,0)
	//! Do initialization of class data members and any other initialization procedure necessary
    virtual void initialize();
	//! Process messages received.
    virtual void handleMessage(cMessage *msg);
	//! Saves summary results (if any)
    virtual void finish();

	virtual ~Observer();
	
// Aditional methods
public:
	void collision();
	void prioError();
	void messageTx(int id);	
	void tournamentStart();
	void tournamentEnd(int id , int result);

private:
	void checkTournament();
};

#endif
