#ifndef __RADIO_H__
#define __RADIO_H__

#include "Debug.h"

enum RADIO_STATES {
	RADIO_STATE_IDLE,		// (0)
	RADIO_STATE_RX_MODE, 	// (1) radio is ready to receive, but not acctually receiving from another node
	RADIO_STATE_RX,			// (2) radio is receiving from another node
	RADIO_STATE_TX_MODE,	// (3) radio is ready to transmit, but not acctually transmitting
	RADIO_STATE_TX			// (4) radio is transmitting
};

enum RCV_MODES {
	RCV_MODE_CARRIER_SENSE,
	RCV_MODE_DATA
};

//! time to switch between tx and rx modes. And also from idle (s) 
#define TURN_AROUND_RXTX 0.000192 // 192 us

//! time to detect a carrier wave 
// TODO: to change/check this... assuming a triangular distribution 
#define TFCS_MIN_VAL 0.000128 // time to get a valid CCA
#define TFCS_MAX_VAL 0.000480 // sometimes it might take longer to detect a carrier...
#define TFCS_AVG_VAL 0.000155 // this is due to the widom implementation...
//const double TFCS_AVG_VAL = TFCS_MIN_VAL + (TFCS_MAX_VAL - TFCS_MIN_VAL) / 2.0;
#define TFCS triang(TFCS_MIN_VAL, TFCS_AVG_VAL, TFCS_MAX_VAL)

// seconds
#define BYTE_TIME	(8.0/250000.0)
// Bytes
#define PREAMBLE_LEN (4)
// frame data time is 
// preamble (includes SFD) +
// frame length (length byte+MPDU+crc)
#define FRAME_TIME(_length)	(BYTE_TIME * ((_length) + PREAMBLE_LEN))

#endif
